"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from orq_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from orq_ai_sdk.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import pydantic
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UpdateSessionBillingTypedDict(TypedDict):
    input_cost: float
    r"""Total cost of the session"""
    output_cost: float
    r"""Total cost of the session"""
    total_cost: float
    r"""Total usage of the session"""


class UpdateSessionBilling(BaseModel):
    input_cost: float
    r"""Total cost of the session"""

    output_cost: float
    r"""Total cost of the session"""

    total_cost: float
    r"""Total usage of the session"""


class UpdateSessionUsageTypedDict(TypedDict):
    prompt_tokens: float
    r"""Total input tokens of the session"""
    completion_tokens: float
    r"""Total output tokens of the session"""
    total_tokens: float
    r"""Total tokens of the session"""


class UpdateSessionUsage(BaseModel):
    prompt_tokens: float
    r"""Total input tokens of the session"""

    completion_tokens: float
    r"""Total output tokens of the session"""

    total_tokens: float
    r"""Total tokens of the session"""


class UpdateSessionRequestBodyTypedDict(TypedDict):
    id: NotRequired[str]
    external_id: NotRequired[str]
    duration: NotRequired[float]
    r"""Duration of the session in ms"""
    contact_ids: NotRequired[List[str]]
    r"""List of contact ids"""
    billing: NotRequired[UpdateSessionBillingTypedDict]
    usage: NotRequired[UpdateSessionUsageTypedDict]
    traces_count: NotRequired[float]
    r"""Total traces of the session"""
    tags: NotRequired[List[str]]
    workspace_id: NotRequired[str]
    r"""The workspace id"""
    project_id: NotRequired[Nullable[str]]
    r"""The project id"""
    started_at: NotRequired[datetime]
    r"""The time when the session was created"""
    updated_at: NotRequired[datetime]
    r"""The time when the session was updated"""


class UpdateSessionRequestBody(BaseModel):
    id: Annotated[Optional[str], pydantic.Field(alias="_id")] = None

    external_id: Optional[str] = None

    duration: Optional[float] = None
    r"""Duration of the session in ms"""

    contact_ids: Optional[List[str]] = None
    r"""List of contact ids"""

    billing: Optional[UpdateSessionBilling] = None

    usage: Optional[UpdateSessionUsage] = None

    traces_count: Optional[float] = None
    r"""Total traces of the session"""

    tags: Optional[List[str]] = None

    workspace_id: Optional[str] = None
    r"""The workspace id"""

    project_id: OptionalNullable[str] = UNSET
    r"""The project id"""

    started_at: Optional[datetime] = None
    r"""The time when the session was created"""

    updated_at: Optional[datetime] = None
    r"""The time when the session was updated"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "_id",
            "external_id",
            "duration",
            "contact_ids",
            "billing",
            "usage",
            "traces_count",
            "tags",
            "workspace_id",
            "project_id",
            "started_at",
            "updated_at",
        ]
        nullable_fields = ["project_id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class UpdateSessionRequestTypedDict(TypedDict):
    session_id: str
    r"""Unique identifier of the session"""
    request_body: NotRequired[UpdateSessionRequestBodyTypedDict]


class UpdateSessionRequest(BaseModel):
    session_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""Unique identifier of the session"""

    request_body: Annotated[
        Optional[UpdateSessionRequestBody],
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ] = None


class UpdateSessionSessionsBillingTypedDict(TypedDict):
    input_cost: float
    r"""Total cost of the session"""
    output_cost: float
    r"""Total cost of the session"""
    total_cost: float
    r"""Total usage of the session"""


class UpdateSessionSessionsBilling(BaseModel):
    input_cost: float
    r"""Total cost of the session"""

    output_cost: float
    r"""Total cost of the session"""

    total_cost: float
    r"""Total usage of the session"""


class UpdateSessionSessionsUsageTypedDict(TypedDict):
    prompt_tokens: float
    r"""Total input tokens of the session"""
    completion_tokens: float
    r"""Total output tokens of the session"""
    total_tokens: float
    r"""Total tokens of the session"""


class UpdateSessionSessionsUsage(BaseModel):
    prompt_tokens: float
    r"""Total input tokens of the session"""

    completion_tokens: float
    r"""Total output tokens of the session"""

    total_tokens: float
    r"""Total tokens of the session"""


class UpdateSessionResponseBodyTypedDict(TypedDict):
    r"""Session"""

    id: str
    external_id: str
    duration: float
    r"""Duration of the session in ms"""
    contact_ids: List[str]
    r"""List of contact ids"""
    billing: UpdateSessionSessionsBillingTypedDict
    usage: UpdateSessionSessionsUsageTypedDict
    traces_count: float
    r"""Total traces of the session"""
    tags: List[str]
    workspace_id: str
    r"""The workspace id"""
    project_id: NotRequired[Nullable[str]]
    r"""The project id"""
    started_at: NotRequired[datetime]
    r"""The time when the session was created"""
    updated_at: NotRequired[datetime]
    r"""The time when the session was updated"""


class UpdateSessionResponseBody(BaseModel):
    r"""Session"""

    id: Annotated[str, pydantic.Field(alias="_id")]

    external_id: str

    duration: float
    r"""Duration of the session in ms"""

    contact_ids: List[str]
    r"""List of contact ids"""

    billing: UpdateSessionSessionsBilling

    usage: UpdateSessionSessionsUsage

    traces_count: float
    r"""Total traces of the session"""

    tags: List[str]

    workspace_id: str
    r"""The workspace id"""

    project_id: OptionalNullable[str] = UNSET
    r"""The project id"""

    started_at: Optional[datetime] = None
    r"""The time when the session was created"""

    updated_at: Optional[datetime] = None
    r"""The time when the session was updated"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["project_id", "started_at", "updated_at"]
        nullable_fields = ["project_id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
